Donors
Replace the duplicate-detection ruleset for a form
Persists a new ruleset for the donor form via DuplicateRule::setRulesForForm (records the editing user). Optional threshold (0–1 confidence floor) and enabled flag are written in a follow-up update on the same row when present. Returns the freshly-loaded rule. Requires permission: duplicates_manage (also satisfied by donors_manage).
PUT
/
admin
/
donors
/
{hysform_id}
/
duplicates
/
rules
Replace the duplicate-detection ruleset for a form
curl --request PUT \
--url https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"rules": [
{
"field_key": "email",
"comparator": "exact"
},
{
"field_key": "first_name",
"comparator": "fuzzy"
}
],
"threshold": 0.8,
"enabled": true
}
'import requests
url = "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules"
payload = {
"rules": [
{
"field_key": "email",
"comparator": "exact"
},
{
"field_key": "first_name",
"comparator": "fuzzy"
}
],
"threshold": 0.8,
"enabled": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
rules: [
{field_key: 'email', comparator: 'exact'},
{field_key: 'first_name', comparator: 'fuzzy'}
],
threshold: 0.8,
enabled: true
})
};
fetch('https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'rules' => [
[
'field_key' => 'email',
'comparator' => 'exact'
],
[
'field_key' => 'first_name',
'comparator' => 'fuzzy'
]
],
'threshold' => 0.8,
'enabled' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules"
payload := strings.NewReader("{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"message": "Duplicate rules updated successfully",
"data": {}
}{
"message": "Unauthorized",
"status": "error"
}{
"errors": {},
"status": "error",
"message": "The given data was invalid."
}{
"success": false,
"message": "Failed to update duplicate rules",
"error": "<string>"
}Authorizations
bearerAuthapiKeyAuth
Passport bearer token authentication for legacy admin sessions.
Path Parameters
Donor form whose ruleset to update.
Body
application/json
Rule definitions. Validation: required|array. Each rule typically pairs a field_key with a comparator (exact, normalized, fuzzy, phonetic).
Example:
[
{
"field_key": "email",
"comparator": "exact"
},
{
"field_key": "first_name",
"comparator": "fuzzy"
}
]
Confidence floor for matches. Validation: sometimes|numeric|min:0|max:1.
Required range:
0 <= x <= 1Example:
0.8
Whether duplicate detection is active for this form. Validation: sometimes|boolean.
Example:
true
⌘I
Replace the duplicate-detection ruleset for a form
curl --request PUT \
--url https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"rules": [
{
"field_key": "email",
"comparator": "exact"
},
{
"field_key": "first_name",
"comparator": "fuzzy"
}
],
"threshold": 0.8,
"enabled": true
}
'import requests
url = "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules"
payload = {
"rules": [
{
"field_key": "email",
"comparator": "exact"
},
{
"field_key": "first_name",
"comparator": "fuzzy"
}
],
"threshold": 0.8,
"enabled": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
rules: [
{field_key: 'email', comparator: 'exact'},
{field_key: 'first_name', comparator: 'fuzzy'}
],
threshold: 0.8,
enabled: true
})
};
fetch('https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'rules' => [
[
'field_key' => 'email',
'comparator' => 'exact'
],
[
'field_key' => 'first_name',
'comparator' => 'fuzzy'
]
],
'threshold' => 0.8,
'enabled' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules"
payload := strings.NewReader("{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.gratona.com/v1/admin/donors/{hysform_id}/duplicates/rules")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"rules\": [\n {\n \"field_key\": \"email\",\n \"comparator\": \"exact\"\n },\n {\n \"field_key\": \"first_name\",\n \"comparator\": \"fuzzy\"\n }\n ],\n \"threshold\": 0.8,\n \"enabled\": true\n}"
response = http.request(request)
puts response.read_body{
"success": true,
"message": "Duplicate rules updated successfully",
"data": {}
}{
"message": "Unauthorized",
"status": "error"
}{
"errors": {},
"status": "error",
"message": "The given data was invalid."
}{
"success": false,
"message": "Failed to update duplicate rules",
"error": "<string>"
}